<template>
  <main v-if="faqItem" class="page-faq">
    <section class="section">
      <div class="wrapper-title">
        <h1 class="main-title">{{ faqItem.title }}</h1>
      </div>
      <ExpandableBlock
        v-for="item in faqItem.blocks"
        :key="item.title"
        :title="item.title"
        :slug="formatText(item.title)"
        :text="item.text"
      />
      <div v-if="faqItem.summary_title" class="summary">
        <button
          :id="faqItem.summary_title"
          @click="copyToClipboard(`#${faqItem.summary_title}`)"
          class="button-anchor"
        >
          <img
            src="@/assets/images/lien.svg"
            loading="lazy"
            class="subtitle-button-img"
            alt=""
          />
          <h2 class="title">{{ faqItem.summary_title }}</h2>
        </button>
        <ul class="faq-list">
          <li v-for="text in faqItem.summary_items" class="summary-text">
            <p v-html="text"></p>
          </li>
        </ul>
      </div>
    </section>
    <section class="section">
      <FaqThemes />
    </section>
  </main>
</template>

<script lang="ts" setup>
import { watch, onMounted, ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRoute } from 'vue-router'
import ExpandableBlock from '@/components/ExpandableBlock.vue'
import FaqThemes from '@/components/FaqThemes.vue'
import { formatBlock, tmWrapper } from '@/utils'
import { copyToClipboard } from '@/utils/slug'
const { locale } = useI18n()
const route = useRoute()
let faqItem = ref<FaqItemData | null>(null)
interface FaqBlock {
  title: string
  text: string
}

interface FaqItemData {
  id: string
  title: string
  blocks: FaqBlock[]
  summary_title: string
  summary_items: [string]
}
type FaqItems = FaqItemData[]
watch(
  () => route.params.id,
  () => updateDatas()
)
watch(
  () => locale.value,
  () => updateDatas()
)
onMounted(() => updateDatas())

function updateDatas(): void {
  const datas: FaqItems = [
    {
      ...tmWrapper('pages.faq.item_legal'),
      id: 'juridique',
      blocks: formatBlock(tmWrapper('pages.faq.item_legal'))
    },
    {
      ...tmWrapper('pages.faq.item_upload'),
      id: 'verser-des-photos',
      blocks: formatBlock(tmWrapper('pages.faq.item_upload'))
    },
    {
      ...tmWrapper('pages.faq.item_instances'),
      id: 'les-instances',
      blocks: formatBlock(tmWrapper('pages.faq.item_instances'))
    },
    {
      ...tmWrapper('pages.faq.item_collect'),
      id: 'collecter-les-photos',
      blocks: formatBlock(tmWrapper('pages.faq.item_collect'))
    },
    {
      ...tmWrapper('pages.faq.item_visualisation'),
      id: 'visualiser-et-utiliser-les-photos',
      blocks: formatBlock(tmWrapper('pages.faq.item_visualisation'))
    },
    {
      ...tmWrapper('pages.faq.item_account'),
      id: 'gerer-mon-compte',
      blocks: formatBlock(tmWrapper('pages.faq.item_account'))
    }
  ]
  faqItem.value = datas.find((e) => e.id === route.params.id) || null
}
function formatText(value: string) {
  return value
    .toLowerCase()
    .normalize('NFD')
    .replace(/[\u0300-\u036f]/g, '')
    .replace(/[^\w ]+/g, '')
    .replace(/ +/g, '-')
}
</script>

<style scoped lang="scss">
.page-faq {
  min-height: calc(100vh - 28rem);
}
.section {
  padding: 3rem 15%;
}
.section:nth-child(even) {
  background-color: var(--white);
}
.section:nth-child(odd) {
  background-color: var(--grey);
}
.main-title {
  @include title();
  margin-right: 2rem;
}
.faq-list {
  list-style-position: inside;
  list-style-type: circle;
}
.wrapper-title {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 5rem;
}
.summary-text {
  list-style: none;
  white-space: pre-wrap;
  font-size: 1.6rem;
  line-height: 1.5;
}
.title {
  font-size: 1.8rem;
  margin-left: 1rem;
}
.summary {
  color: var(--grey-dark);
  margin-top: 4rem;
}
.button-anchor {
  background-color: transparent;
  border: none;
  height: 3.5rem;
  display: flex;
  justify-content: center;
  align-items: center;
  margin-bottom: 1rem;
  cursor: pointer;
}
.button-anchor:hover {
  background-color: var(--blue-pale);
}
.subtitle-button-img {
  height: 2rem;
}
@media (max-width: 1324px) {
  .section {
    padding-right: 10%;
    padding-left: 10%;
  }
}
@media (max-width: 768px) {
  .main-title {
    font-size: 2rem;
  }
  .section {
    padding-right: 2rem;
    padding-left: 2rem;
  }
  .summary-text {
    font-size: 1.4rem;
  }
  .title {
    font-size: 1.6rem;
    margin-bottom: 1rem;
  }
}
</style>
